﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Bulldozer
{
    public class EntityBulldozer
    {
        /// <summary>
        ///  Скорость
        /// </summary>
        public int Speed { get; private set; }
        /// <summary>
        ///  Вес
        /// </summary>
        public double Weight { get; private set; }
        /// <summary>
        ///  Основной цвет
        /// </summary>
        public Color BodyColor { get; private set; }
        /// <summary>
        ///  Дополнительный цвет бульдозера
        /// </summary>
        public Color AdditionalColor { get; private set; }
        /// <summary>
        ///  Дополнительный цвет 
        /// </summary>
        public Color DopColor { get; private set; }
        /// <summary>
        ///  Отвал бульдозера
        /// </summary>
        public bool Blade { get; private set; }
        /// <summary>
        ///  Рыхлитель бульдозера
        /// </summary>
        public bool Ripper { get; private set; }
        /// <summary>
        /// Шаг перемещения бульдозера 
        /// </summary>
        public double Step => (double)Speed * 100 / Weight;
        
        /// <param name="speed">Скорость</param>
        /// <param name="weight">Вес бульдозера</param>
        /// <param name="bodyColor">Основной цвет</param>
        /// <param name="additionalColor">Дополнительный цвет</param>
        /// <param name="blade">Отвал бульдозера</param>
        /// <param name="ripper">Рыхлитель бульдозера</param>
        public void Init(int speed, double weight, Color bodyColor, Color additionalColor, Color dopColor, bool blade, bool ripper)
        {
            Speed = speed;
            Weight = weight;
            BodyColor = bodyColor;
            AdditionalColor = additionalColor;
            DopColor = dopColor;
            Blade = blade;
            Ripper = ripper;
        }
    }
}
