namespace Bulldozer
{
    public partial class FormBulldozer : Form
    {
        private DrawingBulldozer? _drawingBulldozer;

        public FormBulldozer()
        {
            InitializeComponent();
        }

        private void Draw()
        {
            if (_drawingBulldozer == null)
            {
                return;
            }
            Bitmap bmp = new(pictureBoxBulldozer.Width, pictureBoxBulldozer.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _drawingBulldozer.DrawTransport(gr);
            pictureBoxBulldozer.Image = bmp;
        }

        private void ButtonMove_Click(object sender, EventArgs e)
        {
            if (_drawingBulldozer == null)
            {
                return;
            }
            string name = ((Button)sender)?.Name ?? string.Empty;
            switch (name)
            {
                case "buttonUp":
                    _drawingBulldozer.MoveBulldozer(DirectionType.Up);
                    break;
                case "buttonDown":
                    _drawingBulldozer.MoveBulldozer(DirectionType.Down);
                    break;
                case "buttonLeft":
                    _drawingBulldozer.MoveBulldozer(DirectionType.Left);
                    break;
                case "buttonRight":
                    _drawingBulldozer.MoveBulldozer(DirectionType.Right);
                    break;
            }
            Draw();
        }
        
        private void ButtonCreate_Click(object sender, EventArgs e)
        {
            Random random = new();
            _drawingBulldozer = new DrawingBulldozer();
            _drawingBulldozer.Init(random.Next(100, 300),
            random.Next(1000, 3000),
            Color.FromArgb(random.Next(0, 256), random.Next(0, 256),
            random.Next(0, 256)), 
            Color.FromArgb(random.Next(0, 256), random.Next(0, 256),
            random.Next(0, 256)),
            Color.FromArgb(random.Next(0, 256), random.Next(0, 256),
            random.Next(0, 256)),
            Convert.ToBoolean(random.Next(0, 2)),
            Convert.ToBoolean(random.Next(0, 2)),
            pictureBoxBulldozer.Width,
            pictureBoxBulldozer.Height);
            _drawingBulldozer.SetPosition(random.Next(10, 100),random.Next(10, 100));
            Draw();
        }
    }
}